Subject: Re: [PATCH] net: add ability to clear stats via ethtool - e1000/pcnet32

From: Bill Fink <[email-masked]>
Date: Fri, 30 May 2008 15:12:50 -0400

On Thu, 29 May 2008, Alan Cox wrote:

> > > Many of the kernel's accounting accumulators cannot be reset.  We
> > > handle that in userspace tools by using subtraction.
> > 
> > I don't think that should preclude the ability to reset these, unless it is
> > shown that it would break something very badly.
> 
> For one quite a few of the network cards keep the stats in hardware and
> don't neccessarily have a way to reset them. In other cases there is a
> mix of OS accumulated stats bulk updated by overflow events on the device
> itself.
> 
> Its a lot of complexity, and changes all over the places for the sake of
> a trivial userspace change. I would suggest you instead write a quick bit
> of perl or python that fetches the stats and then updates every second
> with the changes.

When diagnosing network problems, the ability to zero counters is
a major aid in diagnosis.  Writing scripts is not a general solution
since often several systems are involved and it's not simple to do
this via a script.  Saving stats output and running beforeafter on
a number of systems is a royal pain when troubleshooting.

I like the idea someone else had. where the clear stats actually did
a checkpoint of the stats, and then future get stats would return the
diff between the checkpointed and current values (perhaps there could
also be a mechanism to still get the absolute values if desired).

						-Bill